import java.util.*;

/**
 * Personenliste mit Funktionen zur Berechnung
 * verschiedener Eigenschaften der Personen in der Liste
 *
 * @author Bernhard Fiser 0109815
 * @version 1.0
 */

public class PersonList
{
	LinkedList		l;
	Person			p;
	private int		a;
	private ListIterator	li;

	/** Initialisiert Personenliste */
	public PersonList(LinkedList list)
	{
		this.l = list;
	}

	/** Ermittelt die Anzahl der Personen in der Liste */
	public int size()
	{
		return l.size();
	}

	/** Ermittelt das Durchschnittsalter aller Personen */
	public int avg_age()
	{
		/* Listeniterator initialisieren und auf den Anfang der Liste setzen */
		li = l.listIterator(0);
		a = 0;

		/* Liste vom ersten bis zum letzten Element traversieren */
		while (li.hasNext())
		{
			/* Aktuelles Personenelemt auslesen */
			p = (Person) li.next();
			/* Durchschnitt berechnen falls nicht erstes Element
			 * (oder Person 0 Jahre alt) */
			if (a == 0)
				a = p.getAlter();
			else
				a = (a + p.getAlter()) / 2;
		}
		return a;
	}

	/** Ermittelt das Alter der jngsten Person */
	public int min_age()
	{
		li = l.listIterator(0);
		a = 1000;

		while (li.hasNext())
		{
			p = (Person) li.next();
			/* Falls Person jnger als vorhergehende Person,
			 * Alter merken */
			if (a > p.getAlter())
				a = p.getAlter();
		}
		return a;
	}

	/** Ermittelt das Alter der ltesten Person */
	public int max_age()
	{
		li = l.listIterator(0);
		a = 0;
		while (li.hasNext())
		{
			p = (Person) li.next();
			/* Falls Person lter als vorhergehende Person,
			 * Alter merken */
			if (a < p.getAlter())
				a = p.getAlter();
		}
		return a;
	}

	/** Listet alle Personen auf die jnger sind als der
	 * angegebene Schwellwert <avg> */
	public int below_avg(int avg)
	{
		li = l.listIterator(0);
		while (li.hasNext())
		{
			p = (Person) li.next();
			/* Falls Person jnger als <avg>, dann Person
			 * auf stdout ausgeben */
			if (p.getAlter() < avg)
				p.print();
		}
		return a;
	}

	/** Listet alle Personen auf, die lter sind als
	 * der angegebene Schwellwert <avg> */
	public int above_avg(int avg)
	{
		li = l.listIterator(0);
		while (li.hasNext())
		{
			p = (Person) li.next();
			/* Falls Person lter als <avg>, dann Person
			 * auf stdout ausgeben */
			if (p.getAlter() > avg)
				p.print();
		}
		return a;
	}
}

