import java.io.*;
import java.util.*;


/** Hauptprogramm zur Personenverwaltung.
 * Liest Personendaten aus Textfile ein,
 * hngt diese in verkettete Liste und gibt statistische
 * Daten ber die Personen aus.
 *
 * @author Bernhard Fiser
 * @version 1.0
 */

class TestPersonenVerwaltung
{
	static PersonenFileReader kate;
	static LinkedList bh;
	static PersonList pl;
	static int		avg;

	public static void main(String argv[])
	{
		/* Neuen PersonenFileReader anlegen, dient
		 * zum einlesen des Personenfiles */
		try
		{
			kate = new PersonenFileReader(argv[0]);
		}

		catch (ArrayIndexOutOfBoundsException e)
		{
			System.out.println("usage: java TestTextFileReader <filename>");
			return;
		}

		/* Personenfile ffnen */
      		try
		{
			kate.open();
		}

		catch (IOException e)
		{
			System.out.println("Error while reading " + argv[0] + ".");
		}

		Person pers = null;

		try
		{
			/* Neues LinkedList-Object erstellen */
			bh = new LinkedList();

			/* Personen aus File auslesen und in verkettete Liste
			 * aufnehmen */
			while ((pers = kate.readNext()) != null)
				bh.add(pers);
		}

		catch (IOException e)
		{
			System.out.println("*** Error in file\n");
		}

		/* Personenfile schliessen */
		try
		{
			kate.close();
		}

		catch (IOException e)
		{
			System.out.println("*** Error closing file\n");
		}

		/* Neues Personenlistenobject erstellen */
		pl = new PersonList(bh);

		/* Statistische Daten ermitteln und auf stdout ausgeben */
		System.out.println("Anzahl der Personen: " + pl.size());
		avg = pl.avg_age();
		System.out.println("Durchschnittsalter: " + avg);
		System.out.println("Juengster Person: " + pl.min_age());
		System.out.println("Alteste Person: " + pl.max_age());
		System.out.println("Personen ueber dem Durchschnitt");
		pl.above_avg(avg);
		System.out.println("Personen unter dem Durchschnitt");
		pl.below_avg(avg);
	}
}
